// *********************************************************************
// Created with BCX32 - BASIC To C/C++ Translator (V) 6.0.2 (2009/12/03)
//                 BCX (c) 1999 - 2009 by Kevin Diggins
// *********************************************************************
//              Translated for compiling with a C Compiler
// *********************************************************************
#include <windows.h>    // Win32 Header File 
#include <windowsx.h>   // Win32 Header File 
#include <commctrl.h>   // Win32 Header File 
#include <commdlg.h>    // Win32 Header File 
#include <mmsystem.h>   // Win32 Header File 
#include <shellapi.h>   // Win32 Header File 
#include <shlobj.h>     // Win32 Header File 
#include <richedit.h>   // Win32 Header File 
#include <wchar.h>      // Win32 Header File 
#include <objbase.h>    // Win32 Header File 
#include <ocidl.h>      // Win32 Header File 
#include <winuser.h>    // Win32 Header File 
#include <olectl.h>     // Win32 Header File 
#include <oaidl.h>      // Win32 Header File 
#include <ole2.h>       // Win32 Header File 
#include <oleauto.h>    // Win32 Header File 
#include <conio.h>
#include <direct.h>
#include <ctype.h>
#include <io.h>
#include <math.h>
#include <stdio.h>
#include <string.h>
#include <stddef.h>
#include <stdlib.h>
#include <setjmp.h>
#include <time.h>
#include <stdarg.h>
#include <process.h>


// ***************************************************
// Compiler Defines
// ***************************************************

// C++
#if defined( __cplusplus )
  #define overloaded
  #define C_EXPORT EXTERN_C __declspec(dllexport)
  #define C_IMPORT EXTERN_C __declspec(dllimport)
#else
  #define C_EXPORT __declspec(dllexport)
  #define C_IMPORT __declspec(dllimport)
#endif

// Open Watcom defs
#if defined( __WATCOM_CPLUSPLUS__ ) || defined( __TINYC__ )
  #define atanl atan
  #define sinl  sin
  #define cosl  cos
  #define tanl  tan
  #define asinl asin
  #define acosl acos
  #define log10l log10
  #define logl   log
  #define _fcloseall fcloseall
#endif

// Borland C++ 5.5.1 defs - bcc32.exe
#if defined( __BCPLUSPLUS__ )
  // ===== Borland Libraries ==========
  #include <dos.h>
  #pragma comment(lib,"import32.lib")
  #pragma comment(lib,"cw32.lib")
  // ==================================
#endif

// Microsoft VC++
#ifndef DECLSPEC_UUID
  #if (_MSC_VER >= 1100) && defined ( __cplusplus )
    #define DECLSPEC_UUID(x)    __declspec(uuid(x))
  #else
    #define DECLSPEC_UUID(x)
  #endif
#endif


#if !defined( __LCC__ )
// *************************************************
// Instruct Linker to Search Object/Import Libraries
// *************************************************
#pragma comment(lib,"kernel32.lib")
#pragma comment(lib,"user32.lib")
#pragma comment(lib,"gdi32.lib")
#pragma comment(lib,"comctl32.lib")
#pragma comment(lib,"advapi32.lib")
#pragma comment(lib,"winspool.lib")
#pragma comment(lib,"shell32.lib")
#pragma comment(lib,"ole32.lib")
#pragma comment(lib,"oleaut32.lib")
#pragma comment(lib,"uuid.lib")
#pragma comment(lib,"odbc32.lib")
#pragma comment(lib,"odbccp32.lib")
#pragma comment(lib,"winmm.lib")
#pragma comment(lib,"comdlg32.lib")
#pragma comment(lib,"imagehlp.lib")
#pragma comment(lib,"version.lib")
#else
#pragma lib <winspool.lib>
#pragma lib <shell32.lib>
#pragma lib <ole32.lib>
#pragma lib <oleaut32.lib>
#pragma lib <uuid.lib>
#pragma lib <odbc32.lib>
#pragma lib <odbccp32.lib>
#pragma lib <winmm.lib>
#pragma lib <imagehlp.lib>
#pragma lib <version.lib>
// *************************************************
// End of Object/Import Libraries To Search
// *************************************************
#endif
// *************************************************
//            User Defined Constants
// *************************************************

#define idOFF 3
#define idON 4
#define idWAV 5
#define idMON 6
#define idQUE 7
#define idVUE 8
#define idWPE 9
#define idHLP 10
#define idABT 11
#define idCPY 12
#define idALL 13
#define idEXT 14
#define WM_SHELLNOTIFY WM_USER +5

// *************************************************
//                System Variables
// *************************************************

char    Date [2048];
char    CRLF[3]={13,10,0}; // Carr Rtn & Line Feed

// *************************************************
//            User Global Variables
// *************************************************

static HFONT   BcxFont;
static float   BCX_ScaleX;
static float   BCX_ScaleY;
static HINSTANCE BCX_hInstance;
static HWND    BCX_hwndMDIClient;
static WNDCLASSEX   BCX_WndClass;
static BOOL    BCX_GUI_Init;
static char    BCX_ClassName[2048];
static HANDLE  hFRM;
static HANDLE  hNXT;
static HANDLE  hLOG;
static HANDLE  hVUE;
static POINT   pt;
static DWORD   d;
static RECT    rc;
static HDWP    hDFR;
static FINDTEXTEX ftx;
static HMENU   hMNU;
static char    DRV[2048];
static char    CBH[2048];
static char    Fnt[2048];
static int     q;
static int     l;
static int     m;
static int     w;
static int     v;
static NOTIFYICONDATA nid;
static HMENU   mTRAY;
static long    TB_CREATED;
static HICON   hICO2;
static HICON   hICO1;



// *************************************************
//               Standard Macros
// *************************************************

#define DefaultFont ((BcxFont==0)?GetStockObject(DEFAULT_GUI_FONT):BcxFont)
#define BCX_Cursor(x)SetCursor(LoadCursor(NULL,x))
#define GET(A,B,C)fread(B,1,C,A)


// *************************************************
//               Standard Prototypes
// *************************************************

void    BCX_SetMetric (char *);
void    BCX_RegWnd (char *, WNDPROC);
void    BCX_InitGUI (void);
int     BCX_MDialog(DLGPROC,char*,HWND,int=0,int=0,int=250,int=150,int=0,int=0,char* =0,int=0);
void    SetDialogScale (HWND, BOOL);
HWND    BCX_Form(char*,int=0,int=0,int=250,int=150,int=0,int=0);
HWND    BCX_RichEdit (char*,HWND,int,int,int,int,int,int=0,int=-1);
void    SetWindowRTFText (HWND, char *);
LPVOID  GetResource(int, char*, DWORD*);
HFONT   BCX_Set_Font (char *,float,int=0,int=0,int=0,int=0,int=0);
void    PlayWav (char *,int=0, int=SND_SYNC);
void    Center (HWND,HWND=0,HWND=0);
char*   BCX_TmpStr(size_t);
char*   sziif (BOOL,char*,char*);
char*   AppExePath (void);
char*   AppExeName (void);
char*   trim (char*);
char*   repeat (int,char*);
char*   GetSpecialFolder (int,int=0,HWND=NULL);
char*   join (int, ... );
char*   chr(int,int=0,int=0,int=0,int=0,int=0,int=0,int=0,int=0,int=0);
char*   LoadFile (char*);
BOOL    Exist   (char*);
BOOL    Exist_A (char*);
BOOL    Exist_B (char*);
DWORD   lof (char*);
double  iif (BOOL,double,double);

// *************************************************
//               User Prototypes
// *************************************************

LRESULT CALLBACK WndProc (HWND, UINT, WPARAM, LPARAM);
void    DeleteHistory (void);
void    History (void);
BOOL    CALLBACK HistoryProc (HWND, UINT, WPARAM, LPARAM);
BOOL    GotDrive (void);
void    FlushClipboard (void);
int     ToggleQue (void);
void    ToggleMon (void);
void    MonitorClipBoard (HWND, BOOL);
void    AppendLog (char *, char *);
BOOL    IsLoaded (char *);
void    Fini (void);
void    PopMenu (LPARAM);
void    TraySetup (void);
void    FormLoad (void);


// *************************************************
//            User Global Initialized Arrays
// *************************************************


// **********************************

int WINAPI WinMain(HINSTANCE hInst,HINSTANCE hPrev,LPSTR CmdLine,int CmdShow)
{
 MSG      Msg;
 strcpy(BCX_ClassName,"Clipboard Magnet");
 BCX_SetMetric("pixels");
 BCX_InitGUI();
 BCX_hInstance       =  hInst;
 BCX_WndClass.hIcon  =  LoadIcon(BCX_hInstance,MAKEINTRESOURCE(2));
 BCX_RegWnd( BCX_ClassName, WndProc );


 // ******************************************
                  FormLoad();
 // ******************************************

 while(GetMessage(&Msg,NULL,0,0))
   {
    HWND hActiveWindow = GetActiveWindow();
    if(!IsWindow(hActiveWindow) || !IsDialogMessage(hActiveWindow,&Msg))
      {
        TranslateMessage(&Msg);
        DispatchMessage(&Msg);
      }
    }
 return Msg.wParam;
}


// *************************************************
//                 Runtime Functions
// *************************************************

char *BCX_TmpStr (size_t Bites)
{
  static int   StrCnt;
  static char *StrFunc[2048];
  StrCnt=(StrCnt + 1) & 2047;
  if(StrFunc[StrCnt]) free (StrFunc[StrCnt]);
  return StrFunc[StrCnt]=(char*)calloc(Bites+128,sizeof(char));
}


char *trim (char *S)
{
  while(*S==32 || *S==9 || *S==10 || *S==11 || *S==13)
    S++;
  register int i = strlen(S);
  while( i>0 && (S[i-1]==32 || S[i-1]==9 || S[i-1]==10
             || S[i-1]==11 || S[i-1]==13))
    i--;
  char *strtmp=BCX_TmpStr(i);
  return (char*)memcpy(strtmp,S,i);
}


char *repeat (int count, char *a)
{
  register char *strtmp = BCX_TmpStr((1+count)*strlen(a));
  while(count-->0) strtmp = strcat(strtmp, a);
  return strtmp;
}


char *chr (int a,int b,int c,int d,int e,int f,int g,int h,int i,int j)
{
  register char *strtmp = BCX_TmpStr(11);
  strtmp[0]  = a;
  strtmp[1]  = b;
  strtmp[2]  = c;
  strtmp[3]  = d;
  strtmp[4]  = e;
  strtmp[5]  = f;
  strtmp[6]  = g;
  strtmp[7]  = h;
  strtmp[8]  = i;
  strtmp[9]  = j;
  strtmp[10] = 0;
  return strtmp;
}


char * join(int n, ...)
{
  register int i = n, tmplen = 0;
  register char *s_;
  register char *strtmp;
  va_list marker;
  va_start(marker, n); // Initialize variable arguments
  while(i-- > 0)
  {
    s_ = va_arg(marker, char *);
    if(s_) tmplen += strlen(s_);
  }
  strtmp = BCX_TmpStr(tmplen);
  va_end(marker); // Reset variable arguments
  i = n;
  va_start(marker, n); // Initialize variable arguments
  while(i-- > 0)
  {
    s_ = va_arg(marker, char *);
    if(s_) strcat(strtmp, s_);
  }
  va_end(marker); // Reset variable arguments
  return strtmp;
}


char *AppExePath (void)
{
 char *strtmp = BCX_TmpStr(2048);
 register int i;
 i=GetModuleFileName(GetModuleHandle(0),strtmp,2048);
 while(i && strtmp[i] != 0x5C)
   i--;
 strtmp[i+1] = 0;
 return strtmp;
}


char *AppExeName (void)
{
  char *strtmp = BCX_TmpStr(2048);
  register int i;
  i=GetModuleFileName(GetModuleHandle(NULL),strtmp,2048);
  while(i && strtmp[i] != 0x5C)
    i--;
  return &strtmp[i+1];
}


BOOL Exist (char *szFilePath)
{
  if(strchr(szFilePath, '*') || strchr(szFilePath, '?'))
  return Exist_A (szFilePath);
  return Exist_B (szFilePath);
}

BOOL Exist_A (char *szFilePath)
{
  WIN32_FIND_DATA W32FindData;
  HANDLE rc;
  rc = FindFirstFile(szFilePath, &W32FindData);
  if(rc == INVALID_HANDLE_VALUE) return FALSE;
  FindClose(rc);
  return TRUE;
}

BOOL Exist_B (char *szFilePath)
{
  DWORD ret;
  ret = GetFileAttributes(szFilePath);
  if (ret != 0xffffffff) return TRUE;
  return FALSE;
}


DWORD lof (char *FileName)
{
  WIN32_FIND_DATA W32FD;
  HANDLE hFile;
  int FSize;
  if(strlen(FileName)==0) return 0;
  hFile=FindFirstFile(FileName,&W32FD);
  if(hFile!=INVALID_HANDLE_VALUE)
   {
     FSize=W32FD.nFileSizeLow;
     FindClose(hFile);
     return FSize;
   }
  return 0;
}


double iif (BOOL cond, double tp, double fp)
{
  if(cond) return tp;
  return fp;
}


char * sziif (BOOL i, char *a, char *b)
{
  if(i) return a;
  return b;
}


char* LoadFile (char *N)
{
  FILE* FP1;
  char* BCX_RetStr;
  if(Exist(N))
    {
      BCX_RetStr=BCX_TmpStr(lof(N));
      if((FP1=fopen(N,"rb"))!=0)
      GET(FP1,BCX_RetStr,lof(N));
      fclose(FP1);
      return BCX_RetStr;
    }
  else
    {
      BCX_RetStr=BCX_TmpStr(64);
      return strcpy(BCX_RetStr,"File Not Found");
    }
}


void PlayWav (char *A, int rsid, int Sync)
{
  if(!rsid)
     PlaySound(A, NULL, SND_FILENAME|SND_NODEFAULT|Sync);
  else
    {
      LPSTR lpRes = (LPSTR)GetResource(rsid, RT_RCDATA, 0);
      if (lpRes==NULL) return; 
      PlaySound(lpRes, NULL, SND_MEMORY|SND_NODEFAULT|Sync);
    }
}


void Center (HWND hwnd, HWND Xhwnd, HWND Yhwnd)
{
  RECT rect, rectP;
  int  x, y, width, height;
  int  screenwidth, screenheight;
  if(Xhwnd==0)
    {
      RECT  DesktopArea;
      RECT  rc;
      SystemParametersInfo(SPI_GETWORKAREA,0,&DesktopArea,0);
      GetWindowRect(hwnd,&rc);
      SetWindowPos(hwnd,HWND_TOP,
        ((DesktopArea.right-DesktopArea.left)-(rc.right-rc.left))/2+
          DesktopArea.left,((DesktopArea.bottom-DesktopArea.top)-
         (rc.bottom-rc.top))/2 + DesktopArea.top,0,0,SWP_NOSIZE);
      return;
    }
  GetWindowRect (hwnd,&rect);
  GetWindowRect (Xhwnd,&rectP);
  width = rect.right-rect.left;
  x = ((rectP.right-rectP.left)-width)/2 + rectP.left;
  if(Yhwnd==NULL)
    {
      height = rect.bottom-rect.top;
      y = ((rectP.bottom-rectP.top)-height)/2 + rectP.top;
    }
  else
    {
      GetWindowRect(Yhwnd,&rectP);
      height = rect.bottom-rect.top;
      y = ((rectP.bottom-rectP.top)-height)/2+rectP.top;
    }
  screenwidth = GetSystemMetrics(SM_CXSCREEN);
  screenheight = GetSystemMetrics(SM_CYSCREEN);
  if ((x<0)) x=0;
  if ((y<0)) y=0;
  if ((x+width>screenwidth))   x = screenwidth-width;
  if ((y+height>screenheight)) y = screenheight-height;
  MoveWindow (hwnd, x, y, width, height, FALSE);
}


int BCX_MDialog (DLGPROC DPro,char* title,HWND hWnd,int X,int Y,int W,int H,int Style,int Exstyle,char *fntface,int fsz)
{
  LPDLGTEMPLATE  lpdt;
  LPWORD  lpw;
  LPVOID tc=calloc(256+(strlen(title)*2),1);
  lpdt=(LPDLGTEMPLATE)tc;
  if(!Style)
   {
     lpdt->style=WS_POPUP|WS_SYSMENU|DS_MODALFRAME|WS_CAPTION;
     if(fsz) lpdt->style=lpdt->style|DS_SETFONT;
   }else{
     lpdt->style=Style;
   }
  lpdt->dwExtendedStyle=Exstyle;
  lpdt->cdit=0;
  lpdt->x =X;  lpdt->y =Y;
  lpdt->cx=W;  lpdt->cy=H;
  
  lpw=(LPWORD)(lpdt+1);
  *lpw++=0; *lpw++=0;
  lpw+=MultiByteToWideChar(CP_ACP,0,title,-1,(LPWSTR)lpw,2*strlen(title)+1);
  if(fsz) { *lpw++ = fsz;
  MultiByteToWideChar(CP_ACP,0,fntface,-1,(LPWSTR)lpw,2*strlen(fntface)+1); }
  int ret=DialogBoxIndirect(BCX_hInstance,(LPDLGTEMPLATE)tc,hWnd,(DLGPROC)DPro);
  free(tc);
  SetDialogScale(0,1);  //restore previous scale
  return ret;
}


void SetDialogScale (HWND hdlg, BOOL Restor)
{
 static float BaseX, BaseY;
 if(Restor&&BaseX)
  {
    BCX_ScaleX=BaseX;
    BCX_ScaleY=BaseY;
    BaseX=BaseY=0;
    return;
  }
 if(!BaseX) { BaseX=BCX_ScaleX; BaseY=BCX_ScaleY; }
 BaseX=BCX_ScaleX; BaseY=BCX_ScaleY;  
 RECT rc = {0, 0, 4, 8};
 MapDialogRect (hdlg, &rc);
 BCX_ScaleX = (float)rc.right/4;
 BCX_ScaleY = (float)rc.bottom/8;
}


HWND BCX_Form(char *Caption,int X,int Y,int W,int H,int Style,int Exstyle)
{
  if(!Style)
    {
       Style= WS_MINIMIZEBOX | WS_SIZEBOX | WS_CAPTION |
              WS_MAXIMIZEBOX | WS_POPUP   | WS_SYSMENU;
    }
  HWND A = CreateWindowEx(Exstyle,BCX_ClassName,Caption,Style,
                          X*BCX_ScaleX,Y*BCX_ScaleY,(4+W)*BCX_ScaleX,(12+H)*BCX_ScaleY,
                          NULL,(HMENU)NULL,BCX_hInstance,NULL);
  SendMessage(A,(UINT)WM_SETFONT,(WPARAM)DefaultFont,(LPARAM)MAKELPARAM(FALSE,0));
  return A;
}


HWND BCX_RichEdit(char* Text,HWND hWnd,int id,int X,int Y,int W,int H,int Style,int Exstyle)
{
  LoadLibrary("RICHED20.DLL");
  HWND  A;
  if(!Style)
    {
      Style=WS_CHILD | WS_CLIPSIBLINGS | WS_VISIBLE   |
            WS_HSCROLL     | WS_VSCROLL      | ES_MULTILINE |
            ES_AUTOVSCROLL | ES_AUTOHSCROLL  | ES_WANTRETURN;
    }
  if(Exstyle==-1)
    {
      Exstyle=WS_EX_CLIENTEDGE;
    }
  A=CreateWindowEx(Exstyle,RICHEDIT_CLASS,NULL,Style,
                   X*BCX_ScaleX, Y*BCX_ScaleY, W*BCX_ScaleX, H*BCX_ScaleY,
                   hWnd,(HMENU)id,BCX_hInstance,NULL);
  SendMessage(A,EM_EXLIMITTEXT,0,1048576); // Increase size to 1 MB
  SetWindowRTFText(A,Text);
  return A;
}


void SetWindowRTFText (HWND hWnd, char *Text)
{
  typedef struct _SETTEXTEX
  {
    UINT  codepage;
    DWORD flags;
  }SETTEXTEX, *LPSETTEXTEX;
  SETTEXTEX  Rtb;
  Rtb.flags=2; //ST_SELECTION;
  Rtb.codepage=CP_ACP;
  SendMessage(hWnd,(UINT)EM_SETTEXTEX,(WPARAM)&Rtb,(LPARAM)Text);
}


LPVOID GetResource(int Res, char *ResType, DWORD *ResSize)
{
  HRSRC hRes;
  HMODULE hMod=GetModuleHandle(NULL);
  hRes=FindResource(hMod,MAKEINTRESOURCE(Res),ResType);
  if(hRes==NULL) return 0;
  if(ResSize) *ResSize=SizeofResource(hMod,hRes);
  return LockResource(LoadResource(hMod,hRes));
}


char *GetSpecialFolder (int nFolder, int bCreate, HWND hWnd)
{
  char *BCX_RetStr=BCX_TmpStr(MAX_PATH);
  if(!SHGetSpecialFolderPath(hWnd,BCX_RetStr,nFolder,bCreate))
    {
      BCX_RetStr[0]=0;
    }
  return BCX_RetStr;
}


HFONT BCX_Set_Font (char *Font,float Size,int Bold,int Italic,int Underline,int StrikeThru,int CharSet)
{
  HDC hDC=GetDC(HWND_DESKTOP);
  int CyPixels=GetDeviceCaps(hDC,LOGPIXELSY);
  ReleaseDC(HWND_DESKTOP,hDC);
  return CreateFont(0-(Size*CyPixels)/72,0,0,0,Bold,Italic,Underline,StrikeThru,
  CharSet,OUT_TT_PRECIS,CLIP_DEFAULT_PRECIS,DEFAULT_QUALITY,FF_DONTCARE,Font);
}


void BCX_SetMetric (char *metric)
{
  if(!BCX_GUI_Init)
    {
      BCX_InitGUI();
    }
  if(stricmp(metric,"PIXELS")==0)
    {
      BCX_ScaleX=1;
      BCX_ScaleY=1;
    }
  else
    {
      RECT  rc={0,0,4,8};
      MapDialogRect(NULL,&rc);
      BCX_ScaleX=rc.right/2;
      BCX_ScaleY=rc.bottom/4;
    }
}


void BCX_RegWnd (char *classname, WNDPROC Form_WndProc)
{
  if(classname[0]==0)
    {
      MessageBox (GetActiveWindow(),"Empty String For BCX_ClassName NOT Allowed","Empty ClassName",0);
      fflush(stdout);
      ExitProcess(1);
    }
  if(GetClassInfoEx( BCX_hInstance, classname, &BCX_WndClass)!=0)
    {
      if(!Form_WndProc)
        {
          UnregisterClass(classname,BCX_hInstance);
        }
      return;
    }
  if(!BCX_GUI_Init)
    {
      BCX_InitGUI();
    }
  if(BCX_ScaleX==0&&BCX_ScaleY==0)
    {
      BCX_SetMetric("Pixels");
    }
  strcpy(BCX_ClassName,classname);
  BCX_WndClass.lpfnWndProc=Form_WndProc;
  BCX_WndClass.hInstance=BCX_hInstance;
  BCX_WndClass.lpszClassName=classname;
  RegisterClassEx(&BCX_WndClass);
}


void BCX_InitGUI (void)
{
  INITCOMMONCONTROLSEX  iccex;
  if(BCX_GUI_Init)
    {
      return;
    }
  BCX_ScaleX=1;
  BCX_ScaleY=1;
  BCX_hInstance=GetModuleHandle(NULL);
  BCX_hwndMDIClient=NULL;
  BCX_WndClass.cbSize=sizeof(BCX_WndClass);
  BCX_WndClass.style=CS_HREDRAW | CS_VREDRAW | CS_OWNDC;
  BCX_WndClass.cbClsExtra=0;
  BCX_WndClass.cbWndExtra=0;
  BCX_WndClass.hIcon= LoadIcon(BCX_hInstance,MAKEINTRESOURCE(2));;
  BCX_WndClass.hCursor=LoadCursor(NULL,IDC_ARROW);
  BCX_WndClass.hbrBackground=(HBRUSH)(COLOR_BTNFACE+1);
  BCX_WndClass.lpszMenuName=NULL;
  BCX_WndClass.hIconSm=NULL;
  iccex.dwSize=sizeof(INITCOMMONCONTROLSEX);
  iccex.dwICC=ICC_LISTVIEW_CLASSES | ICC_TREEVIEW_CLASSES | ICC_BAR_CLASSES | ICC_TAB_CLASSES | ICC_UPDOWN_CLASS | ICC_PROGRESS_CLASS | ICC_USEREX_CLASSES | ICC_DATE_CLASSES;
  InitCommonControlsEx(&iccex);
  BCX_GUI_Init=TRUE;
}



// ************************************
//       User Subs and Functions
// ************************************


LRESULT CALLBACK WndProc (HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
  for(;;)
  {
    if(Msg==WM_DRAWCLIPBOARD)
      {
        if(m==1&v==0&IsClipboardFormatAvailable(CF_TEXT))
          {
            OpenClipboard(hFRM);
            AppendLog(CBH,trim(GetClipboardData(CF_TEXT)));
            CloseClipboard();
          }
        PostMessage(hNXT,Msg,wParam,lParam);
        break;
      }
    if(Msg==WM_COMMAND)
      {
        for(;;)
        {
          if(LOWORD(wParam)==idVUE)
            {
              History();
              break;
            }
          if(LOWORD(wParam)==idMON)
            {
              ToggleMon();
              break;
            }
          if(LOWORD(wParam)==idQUE)
            {
              q=ToggleQue();
              break;
            }
          if(LOWORD(wParam)==idWPE)
            {
              DeleteHistory();
              break;
            }
          if(LOWORD(wParam)==idEXT)
            {
              DestroyWindow(hFRM);
              break;
            }
          if(LOWORD(wParam)==idABT)
            {
              w=1;
              MessageBox (GetActiveWindow(),"Clipboard Magnet","About",0);
              w=0;
            }
          break;
        }
        break;
      }
    if(Msg==WM_SHELLNOTIFY)
      {
        if(w==0)
          {
            PopMenu(lParam);
          }
        break;
      }
    if(Msg==TB_CREATED)
      {
        Shell_NotifyIcon(NIM_ADD, &nid);
        break;
      }
    if(Msg==WM_DESTROY)
      {
        Fini();
        break;
      }
    if(Msg==WM_CHANGECBCHAIN)
      {
        if((HWND)wParam==hNXT)
          {
            hNXT=(HWND)lParam;
          }
        else
          {
            PostMessage(hNXT,Msg,wParam,lParam);
          }
        break;
      }
    if(Msg==WM_CREATE)
      {
        if(IsLoaded(AppExeName()))
          {
            ExitProcess(0);
          }
        else
          {
            TB_CREATED=RegisterWindowMessage("TaskbarCreated");
          }
      }
    break;
  }
 return DefWindowProc(hWnd,Msg,wParam,lParam);
}


void DeleteHistory (void)
{
  w=1;
  if(MessageBox(hFRM,"Delete clipboard history?","Clipboard Magnet",MB_YESNO|MB_ICONQUESTION|MB_TOPMOST|MB_DEFBUTTON2)!=IDNO)
    {
      if(Exist(CBH))
        {
          DeleteFile ((CBH));
        }
    }
  w=0;
}


void History (void)
{
  w=1;
  v=1;
  int     z=m;
  if(z)
    {
      ToggleMon();
    }
  if(!Exist(CBH))
    {
      AppendLog(CBH,join(2,"File created on: ",_strdate(Date)));
    }
  BCX_MDialog(HistoryProc,"Clipboard History",hFRM,0,0,280,200,WS_SIZEBOX|WS_CAPTION|WS_SYSMENU,WS_EX_DLGMODALFRAME|WS_EX_TOPMOST);
  if(z)
    {
      ToggleMon();
    }
  w=0;
  v=0;
}


BOOL CALLBACK HistoryProc (HWND hWnd, UINT Msg, WPARAM wParam, LPARAM lParam)
{
  for(;;)
  {
    if(Msg==WM_INITDIALOG)
      {
        SetDialogScale(hWnd,0);
        hVUE=BCX_RichEdit(LoadFile(CBH),hWnd,0,2,2,276,196,WS_CHILD|WS_VISIBLE|WS_VSCROLL|ES_MULTILINE|ES_AUTOVSCROLL|ES_NOHIDESEL|ES_READONLY,WS_EX_STATICEDGE);
        SendMessage(hVUE,(UINT)WM_SETFONT,(WPARAM)BCX_Set_Font(Fnt,10),1);
        PostMessage(hVUE,EM_SETBKGNDCOLOR,0,GetSysColor(COLOR_BTNFACE));
        PostMessage(hVUE,EM_SETMARGINS,EC_LEFTMARGIN|EC_RIGHTMARGIN,MAKELONG(3,3));
        SetFocus(hVUE);
        Center(hWnd);
        break;
      }
    if(Msg==WM_GETMINMAXINFO)
      {
        LPMINMAXINFO  mmi;
        mmi=(LPMINMAXINFO)lParam;
        mmi->ptMinTrackSize.x=300;
        mmi->ptMinTrackSize.y=224;
        break;
      }
    if(Msg==WM_SIZE)
      {
        if(wParam!=SIZE_MINIMIZED)
          {
            GetClientRect(hWnd, &rc);
            hDFR=BeginDeferWindowPos(1);
            int     cx=rc.right-rc.left;
            int     cy=rc.bottom-rc.top;
            DeferWindowPos(hDFR,hVUE,0,6,6,cx-12,cy-12,SWP_NOZORDER);
            EndDeferWindowPos(hDFR);
          }
        break;
      }
    if(Msg==WM_COMMAND)
      {
        for(;;)
        {
          if(LOWORD(wParam)==idCPY)
            {
              PostMessage(hVUE,WM_COPY,0,0);
              break;
            }
          if(LOWORD(wParam)==idALL)
            {
              ftx.chrg.cpMin=0;
              ftx.chrg.cpMax=-1;
              SendMessage(hVUE,(UINT)EM_EXSETSEL,(WPARAM)0,(LPARAM) &ftx);
              break;
            }
          if(LOWORD(wParam)==idEXT)
            {
              EndDialog(hWnd,0);
            }
          break;
        }
        break;
      }
    if(Msg==WM_INITMENUPOPUP)
      {
        SendMessage(hVUE,(UINT)EM_EXGETSEL,(WPARAM)0,(LPARAM) &ftx);
        int     e=iif(ftx.chrg.cpMin==ftx.chrg.cpMax,1,0);
        EnableMenuItem(hMNU,idCPY,iif(e,MF_GRAYED,MF_ENABLED));
        EnableMenuItem(hMNU,idALL,iif(e,MF_ENABLED,MF_GRAYED));
        SetFocus(hVUE);
        BCX_Cursor(IDC_ARROW);
        break;
      }
    if(Msg==WM_CONTEXTMENU)
      {
        TrackPopupMenuEx(hMNU,TPM_LEFTALIGN|TPM_RIGHTBUTTON,(INT)LOWORD(lParam),(INT)HIWORD(lParam),hWnd,NULL);
        return 1;
      }
    break;
  }
  if(Msg==WM_CLOSE) EndDialog(hWnd,0);
  return 0;
}


BOOL GotDrive (void)
{
  if(!Exist(DRV))
    {
      MessageBox(hFRM,"Current drive is unavailable, aborting...","Clipboard Magnet",MB_OK|MB_ICONERROR);
      return 0;
    }
  else
    {
      return 1;
    }
}


void FlushClipboard (void)
{
  OpenClipboard(hFRM);
  EmptyClipboard();
  CloseClipboard();
}


int ToggleQue (void)
{
  int     g=iif(GetMenuState(mTRAY,idQUE,MF_BYCOMMAND)!=MF_CHECKED,MF_CHECKED,MF_UNCHECKED);
  CheckMenuItem(mTRAY,idQUE,g);
  return g;
}


void ToggleMon (void)
{
  int     g=GetMenuState(mTRAY,idMON,MF_BYCOMMAND);
  int     n;
  for(;;)
  {
    if(g==MF_CHECKED)
      {
        FlushClipboard();
        m=0;
        n=MF_UNCHECKED;
        nid.hIcon=hICO2;
        strcpy(nid.szTip,"Clipboard Magnet Inactive");
        break;
      }
    if(g==MF_UNCHECKED)
      {
        m=1;
        n=MF_CHECKED;
        nid.hIcon=hICO1;
        strcpy(nid.szTip,"Clipboard Magnet Active");
      }
    break;
  }
  MonitorClipBoard(hFRM,m);
  Shell_NotifyIcon(NIM_MODIFY, &nid);
  CheckMenuItem(mTRAY,idMON,n);
}


void MonitorClipBoard (HWND h, BOOL b)
{
  for(;;)
  {
    if(b==1)
      {
        hNXT=SetClipboardViewer(h);
        break;
      }
    if(b==0)
      {
        ChangeClipboardChain(h,hNXT);
      }
    break;
  }
}


void AppendLog (char *f, char *s)
{
  if(!GotDrive())
    {
      ExitProcess(0);
    }
  strcat(s,repeat(2,CRLF));
  l=strlen(s);
  hLOG=CreateFile(f,GENERIC_WRITE,0,NULL,OPEN_ALWAYS,FILE_FLAG_WRITE_THROUGH,0);
  if(!hLOG)
    {
      return;
    }
  SetFilePointer(hLOG,0,0,FILE_END);
  if(!WriteFile(hLOG,s,l, &d,0))
    {
      goto DONE;
    }
  SetEndOfFile(hLOG);
  if(q)
    {
      PlayWav(0,idWAV,SND_ASYNC);
    }

DONE:;
  CloseHandle(hLOG);
}


BOOL IsLoaded (char *UniqueId)
{
  if(OpenMutex(MUTEX_ALL_ACCESS,0,UniqueId)!=0)
    {
      return TRUE;
    }
  else
    {
      CreateMutex(0,1,UniqueId);
      return FALSE;
    }
}


void Fini (void)
{
  MonitorClipBoard(hFRM,0);
  Shell_NotifyIconA(NIM_DELETE, &nid);
  DestroyIcon(hICO2);
  DestroyIcon(hICO1);
  PostQuitMessage(0);
}


void PopMenu (LPARAM j)
{
  if(!w&j==WM_RBUTTONUP)
    {
      SetForegroundWindow(hFRM);
      GetCursorPos( &pt);
      TrackPopupMenuEx(mTRAY,TPM_LEFTALIGN|TPM_RIGHTBUTTON,pt.x,pt.y,hFRM,0);
      PostMessage(hFRM,WM_NULL,0,0);
    }
}


void TraySetup (void)
{
  nid.cbSize=sizeof(NOTIFYICONDATA);
  nid.hWnd=hFRM;
  nid.uFlags=NIF_MESSAGE|NIF_ICON|NIF_TIP;
  nid.uCallbackMessage=WM_SHELLNOTIFY;
  nid.hIcon=hICO2;
  Shell_NotifyIcon(NIM_ADD, &nid);
  mTRAY=CreatePopupMenu();
  AppendMenu(mTRAY,MF_STRING,idVUE,"&Clipboard History");
  AppendMenu(mTRAY,MF_SEPARATOR,0,0);
  AppendMenu(mTRAY,MF_STRING,idMON,"&Monitor");
  AppendMenu(mTRAY,MF_STRING,idQUE,"Audible C&ue");
  AppendMenu(mTRAY,MF_STRING,idWPE,"&Delete History");
  AppendMenu(mTRAY,MF_SEPARATOR,0,0);
  AppendMenu(mTRAY,MF_STRING,idEXT,"E&xit");
}


void FormLoad (void)
{
  strcpy(DRV, join(2,chr(_getdrive()+64),":\\"));
  strcpy(CBH, join(2,AppExePath(),"History.txt"));
  strcpy(Fnt,sziif(Exist(join(2,GetSpecialFolder(CSIDL_FONTS),"\\Dina.fon")),"Dina","Courier New"));
  InitCommonControls();
  w=0;
  m=0;
  v=0;
  if(!Exist(CBH))
    {
      AppendLog(CBH,join(2,"File created on: ",_strdate(Date)));
    }
  hFRM=BCX_Form(0);
  FlushClipboard();
  hICO2=LoadImage(BCX_hInstance,MAKEINTRESOURCE(idOFF),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
  hICO1=LoadImage(BCX_hInstance,MAKEINTRESOURCE(idON),IMAGE_ICON,16,16,LR_DEFAULTCOLOR);
  hMNU=CreatePopupMenu();
  AppendMenu(hMNU,MF_STRING,idCPY,"Copy");
  AppendMenu(hMNU,MF_STRING,idALL,"Select All");
  AppendMenu(hMNU,MF_SEPARATOR,0,0);
  AppendMenu(hMNU,MF_STRING,idHLP,"Help");
  AppendMenu(hMNU,MF_SEPARATOR,0,0);
  AppendMenu(hMNU,MF_STRING,idEXT,"Close");
  TraySetup();
  Center(hFRM);
  ToggleMon();
  q=ToggleQue();
}


